package Cart;
use Apache::Session::DB_File;
use strict;

sub new
{
    my $class = shift;
    my $session_id = shift;
    my $self = bless {
        session => {}
    }, $class;
    $self->_initialize($session_id);
    $self;
}

sub _initialize
{
    my $self = shift;
    my $session_id = shift;

    eval {
        tie %{$self->session}, 'Apache::Session::DB_File',
            $session_id, {
                FileName      => '/usr/home/oyama/var/sessions.db',
                LockDirectory => '/usr/home/oyama/var/lock/sessions',
        };
    };
    if ($@) { die "create_session: $@" }
    $self;
}


sub add_item
{
    my $self = shift;
    my @item = @_;
    push @{$self->session->{item}}, @item;
}

sub delete_item
{
    my $self = shift;
    my $target = shift;
    splice @{$self->session->{item}}, $target, 1;
}

sub item
{
    my $self = shift;
    $self->session->{item} = [] unless exists $self->session->{item};
    return (@{$self->session->{item}});
}


sub session
{
    my $self = shift;
    if (@_) { $self->{session} = shift }
    $self->{session};
}


sub id
{
    my $self = shift;
    $self->session->{_session_id};
}


sub close
{
    my $self = shift;
    $self->{session} = {};
}

sub DESTROY
{
    my $self = shift;
    $self->session->{last_access} = time;
    untie %{$self->session};
}

1;
__END__
