#!/usr/bin/perl

use CGI;
use HTML::Template;
use Catalog;
use Cart;
use strict;


my $query = CGI->new;
my $cart = Cart->new($query->cookie(-name => 'session_id'));
my $mode = $query->param('mode');
if ($mode eq 'add') {
    my $item = load_item($query->param('item'));
    $cart->add_item($item);
}
elsif ($mode eq 'delete') {
    $cart->delete_item($query->param('index'));    
}

my $html = HTML::Template->new(filename => 'cart.html');
my $item_list = [];
my $index = 0;
foreach my $item ($cart->item) {
    push @{$item_list}, { 
        ID      => $item->id,
        NAME    => $item->name,
        PRICE   => $item->price,
        DELETE_CART_URI => 'cart.cgi?mode=delete'. '&index='. $index++,
    };
}    
$html->param(ITEM_LIST    => $item_list);
$html->param(CATALOG_URI  => 'catalog.cgi');
$html->param(REGISTER_URI => 'register.cgi');

my $state_cookie = $query->cookie(
    -name  => 'session_id',
    -value => $cart->id,
    -path  => '/cgi-bin/',
);
print $query->header(-cookie => $state_cookie);
print $html->output;



sub load_item
{
    my $item_id = shift;
    my $catalog = Catalog->new($item_id);
    return $catalog->get_item;
}

