#!/usr/bin/perl

use CGI;
use HTML::Template;
use Catalog;
use strict;

my $query = CGI->new;
my $html = HTML::Template->new(filename => 'catalog.html');
my $catalog = Catalog->new;
my $item_list = [];
while (my $item = $catalog->get_item) {
    push @{$item_list}, { 
        NAME    => $item->name,
        PRICE   => $item->price,
        PHOTO   => $item->photo,
        FEATURE => $item->feature,
        SIZE    => $item->size,
        ADD_CART_URI => 'cart.cgi?mode=add'. '&item='. $item->id
    };    
}
$html->param(ITEM_LIST => $item_list);
$html->param(CART_URI => 'cart.cgi');

print $query->header;
print $html->output;


