#!/usr/bin/perl

use CGI;
use HTML::Template;
use Register;
use Cart;
use Item;
use strict;


my $query = CGI->new;
my $cart = Cart->new($query->cookie(-name => 'session_id'));
if ($query->param('address') and
        $query->param('name') and $query->param('phone')) {
    store_order_information($query, $cart);
    $cart->close;
    show_finish($query);
}
else {
    show_input_form($query, $cart);
}



sub store_order_information
{
    my $query = shift;
    my $cart = shift;
    my $register = Register->new($cart);
    $register->order(
        Address => $query->param('address'),
        Name    => $query->param('name'),
        Phone   => $query->param('phone'),
    );
}


sub show_finish
{
    my $query = shift;
    my $html = HTML::Template->new(
        filename => 'finish.html',
        associate => $query
    );
    $html->param(CATALOG_URI => 'catalog.cgi');
    my $expired_cookie = $query->cookie(
        -name    => 'session_id',
        -value   => '',
        -path    => '/cgi-bin/',
        -expires => 0,
    );
    print $query->header(-cookie => $expired_cookie);
    print $html->output;
}


sub show_input_form
{
    my $query = shift;
    my $cart  = shift;
    my $html = HTML::Template->new(
        filename => 'register.html',
        associate  => $query
    );
    my $item_list = [];
    my $index = 0;
    foreach my $item ($cart->item) {
        push @{$item_list}, {
            NAME    => $item->name,
            PRICE   => $item->price,
            DELETE_CART_URI => 'cart.cgi?mode=delete'. '&index='. $index++,
        };
    }
    $html->param(ITEM_LIST => $item_list);
    $html->param(CATALOG_URI => 'catalog.cgi');
    $html->param(MARKING_ADDRESS => $query->param('address') ? '' : '*');
    $html->param(MARKING_NAME    => $query->param('name')    ? '' : '*');
    $html->param(MARKING_PHONE   => $query->param('phone')   ? '' : '*');

    print $query->header;
    print $html->output;
}

